> For the complete documentation index, see [llms.txt](https://developer.barchart.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.barchart.com/getting-started/requesting-exchanges.md).

# Requesting Exchanges

Request the exchanges available to your username and configuration before subscribing. Openfeed Streaming sends an `ExchangeRequest` and returns an `ExchangeResponse`.

Use the returned exchange codes when creating exchange subscriptions. See [Subscribing to Market Data](/getting-started/subscribing-to-market-data.md) for subscription guidance.

### SDK examples

Use the SDK that matches your application:

* [Python SDK](/repos-sdks/python-sdk.md)
* [Java SDK](/repos-sdks/java-sdk.md)
* [.NET SDK](/repos-sdks/.net-sdk.md)

#### Python

```python
# Handle the exchange response.
def on_message(msg):
    print("Exchange Response:", msg)

# Request all available exchanges and their codes.
of_client.request_available_exchanges(callback=on_message)
```

#### Java

```java
@Override
public void onExchangeResponse(ExchangeResponse exchangeResponse) {
    System.out.println("Exchange Response: " + exchangeResponse);
}

client.exchangeRequest();
```

#### .NET

```csharp
var exchangeList = await client.GetExchangesAsync(CancellationToken.None);

Console.WriteLine("Exchanges Response: " + exchangeList);
```

### Protocol reference

See [api.proto](/architecture/openfeed-api-proto.md) for the `ExchangeRequest` and `ExchangeResponse` message definitions.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developer.barchart.com/getting-started/requesting-exchanges.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
